#line 116 "/home/dodo/SFP/fxform-1.3/src/icon.u"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"


#line 64 "/home/dodo/SFP/fxform-1.3/src/icon.u"

static int has_suffix(char* a, char *sfx)
{
  int La, Lsfx;
  La= strlen(a); Lsfx= strlen(sfx);
  if (La<Lsfx) return 0;
  return !strcasecmp(a+La-Lsfx,sfx);
}
   

static char *read_file_hex(char *fn)
{
   int i;
   int fd;
   fd= open(fn, O_RDONLY);
   if (fd<0)
   {
      fprintf(stderr,"can't open file %s: %s\n", fn,strerror(errno));
      exit(1);
   }

   struct stat sbuf;
   if (fstat(fd, &sbuf))
   {
      fprintf(stderr,"can't stat %s: %s\n", fn,strerror(errno));
      exit(1);
   }

      // 0x0k,
   char *data= malloc(sbuf.st_size * 5 + (sbuf.st_size/10+1) + 1);
   int datao;
   unsigned char idata[10];
   datao= 0;
   while(1)
   {
     int R;
     R= read(fd, idata, 10);
     if (R<=0) break;
     for(i=0;i<R;i++) {
       sprintf(data+datao, "0x%02x,", idata[i]);
       datao+= 5;
     }
     data[datao++]= '\n';
   }
   data[datao]= 0;
   close(fd);
   return data;
}
#line 145 "/home/dodo/SFP/fxform-1.3/src/icon.u"

static char *strlit_escape_decode(char *str)
{
  char *K;
  K= strdup(str+1);
  K[strlen(K)-1]= 0;
  return K; 
}
#line 27 "/home/dodo/SFP/fxform-1.3/src/icon.u"

void put_icon(tpl_t *T, char *name, parser_t *P)
{
   char *fn;
   tpl_t *icon_tpl;
   char *data;
   char *ref;
   char *iname;

icon_tpl= tpl_new(
#line 84 "icon.c"
"@library_objects\n"
"  static FXIcon *$iname;\n"
"  static unsigned char $G_icondata []= {\n"
"$icon_data\n"
"  };\n"
"@GUI_object_creation\n"
"  $iname= new $icon_type(app, $G_icondata);\n"
"  $iname->create();\n"

#line 47 "/home/dodo/SFP/fxform-1.3/src/icon.u"
   );
   ref= P->ipt;
   fn= strlit_escape_decode(parse_strlit(P));
   if (has_suffix(fn,".png")) tpl_replace(icon_tpl, "$icon_type", "FXPNGIcon");
   else
     p_error(P, ref, "unknown file type for icon\n"); 
   data= read_file_hex(fn);
   
   iname= gen_symbol();
   tpl_replace(icon_tpl, "$iname", iname);
   tpl_replace(icon_tpl, "$icon_data", data);
   tpl_builtin(icon_tpl);
   tpl_replace(T, name, iname);
   tpl_append(T, icon_tpl);
}

#line 131 "/home/dodo/SFP/fxform-1.3/src/icon.u"

