#line 130 "/home/dodo/tmp/FX/fxform-1.4/src/property.u"
#include <stdlib.h>
#include "property.h"
#line 19 "/home/dodo/tmp/FX/fxform-1.4/src/property.u"

int prop_common(property_t **L, char* kw)
{
  if (!strcmp(kw,"iconpos"))
  {
    prop_enum(L, "$iconpos", "icon_after_text", "ICON_AFTER_TEXT");
    prop_enum(L, "$iconpos", "icon_before_text", "ICON_BEFORE_TEXT");
    prop_enum(L, "$iconpos", "icon_above_text", "ICON_ABOVE_TEXT");
    prop_enum(L, "$iconpos", "icon_under_text", "ICON_UNDER_TEXT");
    return 1;
  }
  if (!strcmp(kw,"frame"))
  {
    prop_enum(L,"$frame","frame_none", "FRAME_NONE");
    prop_enum(L,"$frame","frame_sunken", "FRAME_SUNKEN");
    prop_enum(L,"$frame","frame_raised", "FRAME_RAISED");
    prop_enum(L,"$frame","frame_thick", "FRAME_THICK");
    prop_enum(L,"$frame","frame_ridge", "FRAME_RIDGE");
    prop_enum(L,"$frame","frame_line", "FRAME_LINE");
    return 1;
  }
  if (!strcmp(kw,"objid"))
  {
    prop_ident(L, "objid");
    return 1;
  }
  if (!strcmp(kw,"layout"))
  {
    prop_flag(L, "pack_left");
    prop_flag(L, "pack_right");
    prop_flag(L, "pack_top");
    prop_flag(L, "pack_bottom");

    prop_flag(L, "fill_x");
    prop_flag(L, "center_x");
    prop_flag(L, "stick_left");
    prop_flag(L, "stick_right");

    prop_flag(L, "fill_y");
    prop_flag(L, "center_y");
    prop_flag(L, "stick_top");
    prop_flag(L, "stick_bottom");

    prop_int(L,"fixed_width");
    prop_int(L,"fixed_height");
    return 1;
  }
  if (!strcmp(kw,"packer"))
  {
    prop_flag(L,"uniform_height");
    prop_flag(L,"uniform_width");
    return 1;
  }
  if (!strcmp(kw,"padding"))
  {
    prop_int(L,"pad_left");
    prop_int(L,"pad_right");
    prop_int(L,"pad_top");
    prop_int(L,"pad_bottom");
    return 1;
  }
  if (!strcmp(kw,"spacing"))
  {
    prop_int(L, "vt_spacing");
    prop_int(L, "hz_spacing");
    return 1;
  }

  return 0;
}

void prop_flag(property_t **L, char *name)
{
  prop_new(L, name, pro_flag, NULL, NULL);
}
void prop_int(property_t **L, char *name)
{
  prop_new(L, name, pro_int, NULL, NULL);
}
void prop_ident(property_t **L, char *name)
{
  prop_new(L, name, pro_ident, NULL, NULL);
}
void prop_enum(property_t **L, char *target, char *name, char *value)
{
  prop_new(L, name, pro_enum, target, value);
}
void prop_str(property_t **L, char *name)
{
  prop_new(L, name, pro_string, NULL, NULL);
}
void prop_font(property_t **L, char *name)
{
  prop_new(L, name, pro_font, NULL, NULL);
}

void prop_new(property_t **L, char *name, int kind, char *target, char *value)
{
  property_t *P;
  P= malloc(sizeof(*P));
  P->name= name; P->kind= kind; P->target= target; P->value= value;
  P->next= *L;
  *L= P;
}

#line 133 "/home/dodo/tmp/FX/fxform-1.4/src/property.u"

