#line 7 "/home/dodo/tmp/FX/fxform-1.4/src/property.u"

enum pro_kind { pro_int, pro_string, pro_ident, pro_float,
                pro_flag, pro_color, pro_font, pro_icon, pro_enum };

typedef struct pro {
  struct pro *next;
  char *name;
  enum pro_kind kind;
  char *target, *value;
} property_t;

#line 13 "property.h"

int prop_common(property_t **L, char* kw);
void prop_flag(property_t **L, char *name);
void prop_int(property_t **L, char *name);
void prop_ident(property_t **L, char *name);
void prop_enum(property_t **L, char *target, char *name, char *value);
void prop_str(property_t **L, char *name);
void prop_font(property_t **L, char *name);
void prop_new(property_t **L, char *name, int kind, char *target, char *value);
