#line 109 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "template.h"
#include "parse.h"
#include "property.h"
#include "prophandler.h"

#line 19 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"

static tpl_t *p_tab(parser_t *P)
{
   tpl_t *child;
   static property_t *props;
   char *kw;
   int child_widget= 0;

   tpl_t *T= tpl_new(
#line 21 "w_tabbook.c"
"@form_constructor\n"
"  FXTabItem *$G_obj;\n"
"  $G_obj= new FXTabItem($container, $dev($title)(\042\042), NULL);\n"
"  // FIXME: do the fonts here\n"

#line 34 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"
   );
                 // FIXME: do the icon stuff here as well
   if (!props) { prop_str(&props, "title"); }

   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (handle_prop_keyword(kw,props, T,P)) continue; 
     child= parse_sub_widget(P, kw);
     if (child)
     {
       if (child_widget) p_error(P,0, "only one child widget is "
                                 "permitted within a tab.\n");
       child_widget= 1;
       tpl_relocations(T, child);
       continue;
     }
     p_error(P,NULL,"unknown keyword %s\n", kw);
   }
   tpl_builtin(T);
   return T;
}

#line 65 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"

tpl_t *p_tab_book(parser_t *P)
{
   char* kw;
   tpl_t *T= tpl_new(
#line 56 "w_tabbook.c"
"@form_constructor\n"
"  FXTabBook *$G_obj;\n"
"  $G_obj= $def($objid)($objid =) new FXTabBook($container,\n"
"           NULL, 0, // selector stuff\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"        0, // FIXME: do the tab-side stuff.\n"
"        0,0,0,0, // xywh\n"
"  $dev($pad_left)(DEFAULT_SPACING),\n"
"  $dev($pad_right)(DEFAULT_SPACING),\n"
"  $dev($pad_top)(DEFAULT_SPACING),\n"
"  $dev($pad_bottom)(DEFAULT_SPACING)\n"
"\n"
"        );\n"
"   <form_constructor>\n"
"\n"
"@form_members $def($objid)(FXTabBook *$objid;)\n"

#line 84 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"
   );
   static property_t *props;
   if (!props) { prop_common(&props, "layout");
                 prop_common(&props, "objid"); }
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
     if (handle_prop_keyword(kw,props, T, P)) continue;
     if (!strcmp(kw,"tab"))
     {
        tpl_t *child;
        child= p_tab(P);
        tpl_replace_var(child, "$container", "$G_obj");
        tpl_relocations(T, child);
        continue;
     }
   }
   tpl_builtin(T);
   return T;
}

#line 119 "/home/dodo/SFP/fxform-1.3/src/w_tabbook.u"

