#!/bin/sh

PNAME=`basename $PWD`

rm -f *.bz2

cd build || exit 1
jj -m  || exit 1

amalgam ../src/amal.txt

cd ..
mkdir $PNAME-dist

cp build/fxform.c  $PNAME-dist
cp build/testgui.fxf  $PNAME-dist
cp build/play.png  $PNAME-dist
cp build/testgui.cc  $PNAME-dist
cp build/actions.h  $PNAME-dist
cp build/Makefile     $PNAME-dist
cp doc/common.txt   $PNAME-dist
cp doc/defwid.txt  $PNAME-dist
cp doc/widgets.txt  $PNAME-dist
cp doc/install.txt  $PNAME-dist
cp COPYING $PNAME-dist

tar cjf $PNAME-dist.tar.bz2 $PNAME-dist
rm -Rf $PNAME-dist


