

#define gui_list_append(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->append_item(Z, __VA_ARGS__ ); } while(0)

#define gui_list_get_selected(X,Y) \
 ({ typeof(X)* Z= &(X); int _K= Z->cls->get_selected(Z,Y); _K; })

 
#define gui_set_all_text(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->set_all_text(_Z, __VA_ARGS__);})

#define gui_remove(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->remove(_Z, __VA_ARGS__);})

#define gui_insert(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->insert(_Z, __VA_ARGS__);})

#define gui_prepend(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->prepend(_Z, __VA_ARGS__);})

#define gui_select_item(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->select_item(_Z, __VA_ARGS__);})

#define gui_get_selected(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->get_selected(_Z, __VA_ARGS__);})

#define gui_clear_selection(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->clear_selection(_Z, __VA_ARGS__);})

#define gui_clear(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->clear(_Z, __VA_ARGS__);})

#define gui_append(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->append(_Z, __VA_ARGS__);})

#define gui_print(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->print(_Z, __VA_ARGS__);})

#define gui_set_current_dir(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->set_current_dir(_Z, __VA_ARGS__);})

#define gui_get_directory(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->get_directory(_Z, __VA_ARGS__);})

#define gui_set_directory(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->set_directory(_Z, __VA_ARGS__);})

#define gui_set_current_file(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->set_current_file(_Z, __VA_ARGS__);})

#define gui_get_current(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->get_current(_Z, __VA_ARGS__);})

#define gui_get_text(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->get_text(_Z, __VA_ARGS__);})

#define gui_set_value(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->set_value(_Z, __VA_ARGS__);})

#define gui_get_value(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->get_value(_Z, __VA_ARGS__);})

#define gui_set_text(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->set_text(_Z, __VA_ARGS__);})

 

 typedef struct gui_radio_group gui_radio_group_t;
 typedef struct 
 {
    void (*set_value)(gui_radio_group_t *object
                                             , int V);
 void (*get_value)(gui_radio_group_t *object
                                             , int *R);

 } gui_radio_group_class_t;

 struct gui_radio_group {
   gui_radio_group_class_t *cls;
   void *widget;
 };



 typedef struct gui_button gui_button_t;
 typedef struct 
 {
    void (*set_text)(gui_button_t *object
                                             ,  const char *text );

 } gui_button_class_t;

 struct gui_button {
   gui_button_class_t *cls;
   void *widget;
 };



 typedef struct gui_newbutton gui_newbutton_t;
 typedef struct 
 {
    void (*set_all_text)(gui_newbutton_t *object
                                             ,  const char * value );

 } gui_newbutton_class_t;

 struct gui_newbutton {
   gui_newbutton_class_t *cls;
   void *widget;
 };



 typedef struct gui_text_field gui_text_field_t;
 typedef struct 
 {
    void (*set_text)(gui_text_field_t *object
                                             ,  const char *text );
 void (*get_text)(gui_text_field_t *object
                                             ,  char **result );

 } gui_text_field_class_t;

 struct gui_text_field {
   gui_text_field_class_t *cls;
   void *widget;
 };



typedef struct gui_intlist gui_intlist_t;

typedef struct {
   int (*get_selected)(gui_intlist_t *, int *);
   int (*select_item)(gui_intlist_t *, int, int);
   void (*clear_selection)(gui_intlist_t *);
   void (*append_item)(gui_intlist_t *, const char *,int);
   void (*prepend_item)(gui_intlist_t *, const char *,int);
   void (*insert_item)(gui_intlist_t *, int, const char *,int);
   void (*remove)(gui_intlist_t *, int);
   void (*clear)(gui_intlist_t *);
} gui_intlist_class_t;


struct gui_intlist {
  gui_intlist_class_t *cls;
  void *widget;
};



typedef struct gui_sslist gui_sslist_t;

typedef struct {
   int (*get_selected)(gui_sslist_t *, char**);
   void (*append_item)(gui_sslist_t *, const char *);
   void (*prepend_item)(gui_sslist_t *, const char *);
   void (*insert_item)(gui_sslist_t *, const char* , const char *);
} gui_sslist_class_t;

struct gui_sslist {
  gui_sslist_class_t *cls;
  void *widget;
};




typedef struct gui_slist gui_slist_t;

typedef struct {
   int  (*get_selected)(gui_slist_t *, char**);
   void (*append_item)(gui_slist_t *, const char *,const char*);
   void (*prepend_item)(gui_slist_t *, const char *,const char*);
   void (*insert_item)(gui_slist_t *, const char* , const char *,const char*);
   void (*remove)(gui_slist_t *,const char *);
} gui_slist_class_t;

struct gui_slist {
  gui_slist_class_t *cls;
  void *widget;
};



 typedef struct gui_message_console gui_message_console_t;
 typedef struct 
 {
    void (*print)(gui_message_console_t *object
                                             , const char *fmt, ...);
 void (*append)(gui_message_console_t *object
                                             , const char *str, size_t len);
 void (*clear)(gui_message_console_t *object
                                              );

 } gui_message_console_class_t;

 struct gui_message_console {
   gui_message_console_class_t *cls;
   void *widget;
 };



 typedef struct gui_dir_list gui_dir_list_t;
 typedef struct 
 {
    void (*set_current_file)(gui_dir_list_t *object
                                             , const char *fn);
 void (*set_current_dir)(gui_dir_list_t *object
                                             , const char *fn);
 void (*get_current)(gui_dir_list_t *object
                                             , int *result, const char **name, int *type);

 } gui_dir_list_class_t;

 struct gui_dir_list {
   gui_dir_list_class_t *cls;
   void *widget;
 };



 typedef struct gui_file_list gui_file_list_t;
 typedef struct 
 {
    void (*get_current)(gui_file_list_t *object
                                             ,  int *Rresult, const char **Rname, int *Rtype );
 void (*set_current_file)(gui_file_list_t *object
                                             ,  const char *fn );
 void (*set_directory)(gui_file_list_t *object
                                             ,  const char *fn );
 void (*get_directory)(gui_file_list_t *object
                                             ,  char **fn );

 } gui_file_list_class_t;

 struct gui_file_list {
   gui_file_list_class_t *cls;
   void *widget;
 };



 typedef struct gui_int_list gui_int_list_t;
 typedef struct 
 {
    void (*clear_selection)(gui_int_list_t *object
                                              );
 void (*get_selected)(gui_int_list_t *object
                                             , int *R, int *key);
 void (*select_item)(gui_int_list_t *object
                                             ,  int key, int sel );
 void (*append)(gui_int_list_t *object
                                             ,  const char *text, int key );
 void (*prepend)(gui_int_list_t *object
                                             ,  const char *text, int key );
 void (*insert)(gui_int_list_t *object
                                             ,  int poskey, const char *text, int key );
 void (*remove)(gui_int_list_t *object
                                             ,  int key );
 void (*clear)(gui_int_list_t *object
                                              );

 } gui_int_list_class_t;

 struct gui_int_list {
   gui_int_list_class_t *cls;
   void *widget;
 };


#ifdef __cplusplus
extern "C" {
#endif

void gui_init(int *argc,char **argv);
void gui_run();
void gui_flush();

#ifdef __cplusplus
}
#endif
 

typedef struct {
  void *self;
   gui_radio_group_t radio1;
 gui_button_t cool_button;
 gui_button_t foo_button;
 gui_newbutton_t allnew;
 gui_text_field_t source_dir;

  gui_intlist_t numbers;


  gui_sslist_t strings;


  gui_slist_t string_keys;

 gui_message_console_t econ;
 gui_dir_list_t dirs;
 gui_file_list_t files;
 gui_int_list_t newilist;

} gui_testmain_t;

#ifdef __cplusplus
extern "C" {
#endif

gui_testmain_t *gui_c_testmain();

#ifdef __cplusplus
}
#endif



