
#include <stdio.h>
#include <string.h>
#include "gui.h"
#include "actions.h"

gui_testmain_t *TW;

void press_bye()
{
  gui_set_text(TW->cool_button, "HA!");
}

void press_hello()
{
  gui_set_text(TW->foo_button, "HO!");
}

void test_int_list()
{
  int S;
  if (gui_list_get_selected(TW->numbers, &S))
     gui_print(TW->econ,"selected: %d\n", S);
  else 
     gui_print(TW->econ,"no selection\n");
}

void test_new_button()
{
  static int k= 0;
  gui_set_all_text(TW->allnew, strdup((k++)%2 ? "This is it!" : "All is well!"));
}

void test_str_list()
{
  char* S;
  if (gui_list_get_selected(TW->string_keys, &S))
     gui_print(TW->econ,"selected: %s\n", S);
  else 
     gui_print(TW->econ,"no selection\n");
}

void test_dispstr_list()
{
  char* S;
  if (gui_list_get_selected(TW->strings, &S))
     gui_print(TW->econ,"selected: %s\n", S);
  else gui_print(TW->econ,"no selection\n");
}

int main(int argc,char **argv)
{
  int i;
  const char *num[]= {
   "one", "two", "three", "four", "five", 0
  };
  const char *fruit[]= {
   "elma", "apple", "portakal", "orange",
   "muz", "banana", "visne", "cherry",
   "armut", "pear", 0,0
  };
  gui_init(&argc,argv);
  TW= gui_c_testmain();

  for(i=0;num[i];i++) gui_list_append(TW->numbers, num[i], i+1);
  for(i=0;num[i];i++) gui_list_append(TW->strings, num[i]);

  for(i=0;num[i];i++) gui_append(TW->newilist, num[i], i+1);

  for(i=0;fruit[i];i+=2)
      gui_list_append(TW->string_keys,fruit[i], fruit[i+1]);
  gui_run();
  return 0;
}
