#line 347 "/home/dodo/SFP/fxform-1.3/src/w_list.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"
#include "property.h"
#include "prophandler.h"

#line 67 "/home/dodo/SFP/fxform-1.3/src/w_list.u"

tpl_t *p_list(parser_t *P)
{
   char *kw;
   int KT= 'd';
   tpl_t *T= tpl_new(
#line 18 "w_list.c"
"\n"
"@form_constructor\n"
"   FXList *$G_obj; \n"
"\n"
"   $G_obj= $def($objid)($objid =) new FXList($container,\n"
"        $def($click_sig $dclick_sig)(this)\n"
"           $nef($dclick_sig $click_sig)(NULL),\n"
"        $def($click_sig $dclick_sig)($G_selector)\n"
"           $nef($dclick_sig $click_sig)(0),\n"
"\n"
"  $def($pack_left)(LAYOUT_SIDE_LEFT|)\n"
"  $def($pack_right)(LAYOUT_SIDE_RIGHT|)\n"
"  $def($pack_top)(LAYOUT_SIDE_TOP|)\n"
"  $def($pack_bottom)(LAYOUT_SIDE_BOTTOM|)\n"
"\n"
"  $def($stick_left)(LAYOUT_LEFT |)\n"
"  $def($stick_right)(LAYOUT_RIGHT|)\n"
"  $def($stick_top)(LAYOUT_TOP|)\n"
"  $def($stick_bottom)(LAYOUT_BOTTOM|)\n"
"\n"
"  $def($fill_x)(LAYOUT_FILL_X|)\n"
"  $def($fill_y)(LAYOUT_FILL_Y|)\n"
"  $def($fixed_width)(LAYOUT_FIX_WIDTH|)\n"
"  $def($fixed_height)(LAYOUT_FIX_HEIGHT|)  \n"
"\n"
"           0\n"
"            ,0,0,0,0); // xywh\n"
"\n"
"\n"
" $def($font_size $font_family $font_weight $font_width $font_slant)\n"
"   (\n"
"      FXFontDesc $G_font_desc;\n"
"      $G_obj->getFont()->getFontDesc($G_font_desc);\n"
"      $def($font_size)(\n"
"         $G_font_desc.size= $font_size * 10;\n"
"      )\n"
"      $def($font_family)( strcpy($G_font_desc.face, $font_family);)\n"
"      $def($font_slant)( $G_font_desc.slant= $font_slant;)\n"
"      $def($font_weight)( $G_font_desc.weight= $font_weight;)\n"
"      $def($font_width)( $G_font_desc.setwidth= $font_width;)\n"
"\n"
"      $G_font= new FXFont(FXApp::instance(), $G_font_desc);\n"
"      $G_obj->setFont($G_font);\n"
"      @library_code  static FXFont *$G_font;\n"
"   )\n"
"\n"
"@form_members\n"
"  $def($objid)(FXList *$objid;)\n"
"\n"
"@form_widget_declarations\n"
"  $def($objid)($list_struct_name $objid;)\n"
"\n"
"@form_widget_export\n"
"  $def($objid)(\n"
"    ifo->$objid.cls= & $list_class_var;\n"
"    ifo->$objid.widget= ffo->$objid;\n"
"  ) \n"
"\n"
"@form_members\n"
"  $def($click_sig)(long $G_click(FXObject *object,FXSelector sel,void* arg);)\n"
"  $def($dclick_sig)(long $G_dclick(FXObject *object,FXSelector sel,void* arg);)\n"
"\n"
"@form_signal_mappings\n"
"  $def($click_sig)(\n"
"     FXMAPFUNC(SEL_CLICKED,$form_class::$G_selector,$form_class::$G_click),)\n"
"  $def($dclick_sig)(\n"
"     FXMAPFUNC(SEL_DOUBLECLICKED,$form_class::$G_selector,$form_class::$G_dclick),)\n"
"\n"
"@form_selector_ids\n"
"  $def($click_sig $dclick_sig)($G_selector,)\n"
"\n"
"@form_methods\n"
"$def($click_sig)(\n"
" long $form_class::$G_click\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
"    {\n"
"      FXList *$G_list= (FXList*)(object);\n"
"      int clicked_item= (intptr_t) (arg);\n"
"      FYListItem *item= (FYListItem*) ($G_list->getItem(clicked_item));\n"
"\n"
"      $def($type_is_int)(int clicked_key = item->data_i;)\n"
"      $def($type_is_str)(char* clicked_key= item->data_p; )\n"
"      $def($type_is_flo)(double clicked_key= item->data_f;)\n"
"      $def($type_is_ptr)(void* clicked_key= item->data_p;)\n"
"      $click\n"
"      return 1;\n"
"    }\n"
")\n"
"$def($dclick_sig)(\n"
" long $form_class::$G_dclick\n"
"    (FXObject *object,FXSelector sel, void *arg)\n"
"    {\n"
"      FXList *$G_list= (FXList*)(object);\n"
"      int clicked_item= (intptr_t) (arg);\n"
"      FYListItem *item= (FYListItem*) ($G_list->getItem(clicked_item));\n"
"\n"
"      $def($type_is_int)(int clicked_key = item->data_i;)\n"
"      $def($type_is_str)(char* clicked_key= item->data_p; )\n"
"      $def($type_is_flo)(double clicked_key= item->data_f;)\n"
"      $def($type_is_ptr)(void* clicked_key= item->data_p;)\n"
"      $dclick\n"
"      return 1;\n"
"    }\n"
")\n"
"\n"

#line 76 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
   );
   static property_t *props;
   if (!props)
   {
     prop_common(&props, "layout");
     prop_common(&props, "objid");
     prop_font(&props, "font");
   }
   parse_lcurly(P);
   while((kw=parse_ident_or_rcurly(P)))
   {
    if (handle_prop_keyword(kw, props, T,P)) continue;
    if (!strcmp(kw,"key"))
    { 
       char *typ= parse_ident(P);
       if (!strcmp(typ,"int")) KT= 'i'; 
       else if (!strcmp(typ,"double")) KT= 'F';
       else if (!strcmp(typ,"string")) KT= 's';
       else if (!strcmp(typ,"ptr")) {
          KT= 'P';
       } else  
          p_error(P, 0, "unknown list key type: %s\n", typ);
       switch(KT) {
       case 'i': tpl_replace(T,"$type_is_int", "y"); break;
       case 'F': tpl_replace(T,"$type_is_flo", "y"); break;
       case 's': tpl_replace(T,"$type_is_ptr", "y"); break;
       case 'P': tpl_replace(T,"$type_is_str", "y"); break;
       }
       continue;
    }
#line 587 "/home/dodo/SFP/fxform-1.3/src/w_list.u"

  if (!strcmp(kw,"click")) {
            tpl_replace(T, "$click", parse_cpp(P));
            tpl_replace(T, "$click_sig", "y");  continue; }
  if (!strcmp(kw,"double_click")) { 
            tpl_replace(T, "$dclick", parse_cpp(P));
            tpl_replace(T, "$dclick_sig", "y");  continue; }

#line 107 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
   // FIXME: do the scrollbar stuff here
   }
#line 318 "/home/dodo/SFP/fxform-1.3/src/w_list.u"

static int common_cls= 0;
if (!common_cls) {
  tpl_append(T, tpl_new(
#line 172 "w_list.c"
"\n"
"@library_code\n"
"\n"
"class FYListItem : public FXListItem \n"
"{\n"
"  FXDECLARE(FYListItem)\n"
"protected:\n"
"  FYListItem() : FXListItem() { }\n"
"public:\n"
"  FYListItem(const FXString& text,FXIcon* ic, void *pdata)\n"
"   : FXListItem(text,ic,NULL)\n"
"  { data_p= pdata; }\n"
"  FYListItem(const FXString& text,FXIcon* ic, int idata)\n"
"   : FXListItem(text,ic,NULL)\n"
"  { data_i= idata; }\n"
"  FYListItem(const FXString& text,FXIcon* ic, double fdata)\n"
"   : FXListItem(text,ic,NULL)\n"
"  { data_f= fdata; }\n"
"  ~FYListItem() { }\n"
"// These could be in a union, but who cares about space\n"
"  int data_i;\n"
"  double data_f;\n"
"  void *data_p;\n"
"};\n"
"\n"
"\n"
"FXIMPLEMENT(FYListItem,FXListItem,NULL,0)\n"
"\n"
"\n"
"@library_code\n"
"\n"
"static void clear_selection\n"
"  (FXList *L)\n"
"{\n"
"  int i;\n"
"  int N= L->getNumItems();\n"
"  for(i=0;i<N;i++)\n"
"    L->deselectItem(i);\n"
"}\n"
"\n"
"static FYListItem* get_selected(FXList *L)\n"
"{\n"
"   int i, N= L->getNumItems();\n"
"   for(i=0;i<N;i++)\n"
"     if (L->isItemSelected(i))\n"
"       return (FYListItem*) L->getItem(i);\n"
"   return 0;\n"
"}\n"
"\n"

#line 326 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
  ));
  common_cls= 1;
}

if (KT=='i') {
  tpl_replace(T, "$list_class_var", "gui_intlist_class");
  tpl_replace(T, "$list_struct_name", "gui_intlist_t");
  static int cls=0;
  if (!cls) {
    tpl_append(T, tpl_new(
#line 233 "w_list.c"
"\n"
"@library_interface\n"
"\n"
"typedef struct gui_intlist gui_intlist_t;\n"
"\n"
"typedef struct {\n"
"   int (*get_selected)(gui_intlist_t *, int *);\n"
"   int (*select_item)(gui_intlist_t *, int, int);\n"
"   void (*clear_selection)(gui_intlist_t *);\n"
"   void (*append_item)(gui_intlist_t *, const char *,int);\n"
"   void (*prepend_item)(gui_intlist_t *, const char *,int);\n"
"   void (*insert_item)(gui_intlist_t *, int, const char *,int);\n"
"   void (*remove)(gui_intlist_t *, int);\n"
"   void (*clear)(gui_intlist_t *);\n"
"} gui_intlist_class_t;\n"
"\n"
"\n"
"struct gui_intlist {\n"
"  gui_intlist_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"@library_code\n"
"\n"
"static inline FXList* list(gui_intlist_t *IL)\n"
"{\n"
"  return (FXList*) (IL->widget);\n"
"}\n"
"\n"
"static int intlist_get_selected\n"
"   (gui_intlist_t* IL, int *ret)\n"
"{\n"
"  FYListItem *item= get_selected(list(IL));\n"
"  if (item) { *ret= item->data_i; return 1; }\n"
"  return 0;\n"
"}\n"
"\n"
"static void intlist_clear(gui_intlist_t* IL)\n"
"{\n"
"  list(IL)->clearItems();\n"
"}\n"
"\n"
"static int intlist_find_item(gui_intlist_t *IL, int key)\n"
"{\n"
"  int i;\n"
"  FXList* L= list(IL);\n"
"  int N= L->getNumItems();\n"
"  for(i=0;i<N;i++)\n"
"    {\n"
"        FYListItem *it= (FYListItem*) L->getItem(i);\n"
"        if (it->data_i==key) return i;\n"
"    }\n"
"  return -1;\n"
"}\n"
"\n"
"static int intlist_select_item\n"
"  (gui_intlist_t *IL, int key,int sel)\n"
"{\n"
"  int i= intlist_find_item(IL, key); \n"
"  if (i==-1) return 0;\n"
"  if (sel) list(IL)->selectItem(i);\n"
"  else list(IL)->deselectItem(i); \n"
"  return 1;\n"
"}\n"
"\n"
"\n"
"static void intlist_append_item\n"
"  (gui_intlist_t *IL, const char *text, int key)\n"
"{\n"
"  list(IL)->appendItem(new FYListItem(text, NULL,key));\n"
"}\n"
"\n"
"static void intlist_prepend_item\n"
"  (gui_intlist_t *IL, const char *text, int key)\n"
"{\n"
"  list(IL)->prependItem(new FYListItem(text, NULL,key));\n"
"}\n"
"\n"
"static void intlist_insert_item\n"
"  (gui_intlist_t *IL, int poskey, const char *text, int key)\n"
"{\n"
"  int i= intlist_find_item(IL, poskey);\n"
"  if (i!=-1)\n"
"    list(IL)->insertItem(i, new FYListItem(text, NULL, key));\n"
"  else\n"
"    list(IL)->appendItem(new FYListItem(text, NULL, key));\n"
"}\n"
"\n"
"static void intlist_clear_selection(gui_intlist_t *IL)\n"
"{\n"
"  clear_selection(list(IL));\n"
"}\n"
"\n"
"static void intlist_remove_item(gui_intlist_t *IL, int key)\n"
"{\n"
"  int i= intlist_find_item(IL, key);\n"
"  if (i==-1) return ;\n"
"  list(IL)->removeItem(i);\n"
"}\n"
"\n"
"static gui_intlist_class_t gui_intlist_class=\n"
"{\n"
"   intlist_get_selected,\n"
"   intlist_select_item,\n"
"   intlist_clear_selection,\n"
"   intlist_append_item,\n"
"   intlist_prepend_item,\n"
"   intlist_insert_item,\n"
"   intlist_remove_item,\n"
"   intlist_clear,\n"
"};\n"
"\n"

#line 339 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
    ));
    cls= 1;
  }
}
#line 440 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
  // d stands for "displayed string"
if (KT=='d') {
  tpl_replace(T, "$list_class_var", "gui_sslist_class");
  tpl_replace(T, "$list_struct_name", "gui_sslist_t");
  static int cls=0;
  if (!cls) {
    tpl_append(T, tpl_new(
#line 359 "w_list.c"
"\n"
"@library_interface\n"
"\n"
"typedef struct gui_sslist gui_sslist_t;\n"
"\n"
"typedef struct {\n"
"   int (*get_selected)(gui_sslist_t *, char**);\n"
"   void (*append_item)(gui_sslist_t *, const char *);\n"
"   void (*prepend_item)(gui_sslist_t *, const char *);\n"
"   void (*insert_item)(gui_sslist_t *, const char* , const char *);\n"
"} gui_sslist_class_t;\n"
"\n"
"struct gui_sslist {\n"
"  gui_sslist_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"\n"
"@library_code\n"
"\n"
"static FXList* list(gui_sslist_t *SL)\n"
"{\n"
"  return (FXList*) SL->widget;\n"
"}\n"
"\n"
"static int sslist_get_selected(gui_sslist_t *SL, char **ret)\n"
"{\n"
"  FYListItem *item= get_selected(list(SL));\n"
"  if (!item) return 0;\n"
"  *ret= (char*) item->data_p;\n"
"  return 1;\n"
"}\n"
"\n"
"static int sslist_find_item(gui_sslist_t *SL,const char *key)\n"
"{\n"
"  FXList *L= list(SL);\n"
"  int i, N= L->getNumItems();\n"
"  for(i=0;i<N;i++) {\n"
"    FYListItem* item= (FYListItem*) L->getItem(i);\n"
"    if (!strcmp((char*) item->data_p, key)) return i;\n"
"  }\n"
"  return -1;\n"
"}\n"
"\n"
"static void sslist_append_item(gui_sslist_t *SL, const char *value)\n"
"{\n"
"  list(SL)->appendItem(new FYListItem(value, NULL, (void*) value));\n"
"}\n"
"static void sslist_prepend_item(gui_sslist_t *SL, const char *value)\n"
"{\n"
"  list(SL)->prependItem(new FYListItem(value, NULL, (void*) value));\n"
"}\n"
"static void sslist_insert_item\n"
"      (gui_sslist_t *SL, const char *poskey, const char *value)\n"
"{\n"
"  int i= sslist_find_item(SL, poskey);\n"
"  if (i==-1) sslist_append_item(SL, value);\n"
"  else list(SL)->insertItem(i,new FYListItem(value, NULL, (void*) value));\n"
"}\n"
"\n"
"static gui_sslist_class_t gui_sslist_class= {\n"
"  sslist_get_selected,\n"
"  sslist_append_item,\n"
"  sslist_prepend_item,\n"
"  sslist_insert_item\n"
"};\n"
"\n"

#line 450 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
    ));
    cls= 1;
  }
}
#line 558 "/home/dodo/SFP/fxform-1.3/src/w_list.u"


if (KT=='s') {
  tpl_replace(T, "$list_class_var", "gui_slist_class");
  tpl_replace(T, "$list_struct_name", "gui_slist_t");
  static int cls=0;
  if (!cls) {
    tpl_append(T, tpl_new(
#line 441 "w_list.c"
"\n"
"@library_interface\n"
"\n"
"typedef struct gui_slist gui_slist_t;\n"
"\n"
"typedef struct {\n"
"   int  (*get_selected)(gui_slist_t *, char**);\n"
"   void (*append_item)(gui_slist_t *, const char *,const char*);\n"
"   void (*prepend_item)(gui_slist_t *, const char *,const char*);\n"
"   void (*insert_item)(gui_slist_t *, const char* , const char *,const char*);\n"
"   void (*remove)(gui_slist_t *,const char *);\n"
"} gui_slist_class_t;\n"
"\n"
"struct gui_slist {\n"
"  gui_slist_class_t *cls;\n"
"  void *widget;\n"
"};\n"
"\n"
"@library_code\n"
"\n"
"static FXList* list(gui_slist_t *SL)\n"
"{\n"
"  return (FXList*) SL->widget;\n"
"}\n"
"\n"
"static int slist_get_selected(gui_slist_t *SL, char **ret)\n"
"{\n"
"  FYListItem *item= get_selected(list(SL));\n"
"  if (!item) return 0;\n"
"  *ret= (char*) item->data_p;\n"
"  return 1;\n"
"}\n"
"\n"
"static int slist_find_item(gui_slist_t *SL,const char *key)\n"
"{\n"
"  FXList *L= list(SL);\n"
"  int i, N= L->getNumItems();\n"
"  for(i=0;i<N;i++) {\n"
"    FYListItem* item= (FYListItem*) L->getItem(i);\n"
"    if (!strcmp((char*) item->data_p, key)) return i;\n"
"  }\n"
"  return -1;\n"
"}\n"
"\n"
"static void slist_append_item\n"
"    (gui_slist_t *SL, const char *value, const char *data)\n"
"{\n"
"  list(SL)->appendItem(new FYListItem(value, NULL, (void*) data));\n"
"}\n"
"\n"
"static void slist_prepend_item\n"
"   (gui_slist_t *SL, const char *value,const char *data)\n"
"{\n"
"  list(SL)->prependItem(new FYListItem(value, NULL, (void*) data));\n"
"}\n"
"\n"
"static void slist_insert_item\n"
"      (gui_slist_t *SL, const char *poskey,\n"
"       const char *value,const char *data)\n"
"{\n"
"  int i= slist_find_item(SL, poskey);\n"
"  if (i==-1) slist_append_item(SL, value,data);\n"
"  else list(SL)->insertItem(i,new FYListItem(value, NULL, (void*) data));\n"
"}\n"
"\n"
"static void slist_remove_item\n"
"      (gui_slist_t *SL, const char *key)\n"
"{\n"
"  int i= slist_find_item(SL, key);\n"
"  if (i!=-1)\n"
"     list(SL)->removeItem(i);\n"
"}\n"
"\n"
"static gui_slist_class_t gui_slist_class= {\n"
"  slist_get_selected,\n"
"  slist_append_item,\n"
"  slist_prepend_item,\n"
"  slist_insert_item,\n"
"  slist_remove_item,\n"
"};\n"
"\n"

#line 569 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
    ));
    cls= 1;
  }
}

#line 110 "/home/dodo/SFP/fxform-1.3/src/w_list.u"
   tpl_builtin(T);
   define_verb("select_item");
   define_verb("append");
   define_verb("remove");
   define_verb("clear_selection");
   return T;
}
#line 357 "/home/dodo/SFP/fxform-1.3/src/w_list.u"

